﻿using System;
using System.Threading;
using System.Windows.Forms;
using jkType;
using jakaApi;
using System.Drawing;


namespace RobotTeach
{
    public partial class Teach : Form
    {
        int rshd = -1;
        bool login = false;
        bool teach;
        double r2d = 180/Math.PI;
        double d2r = Math.PI/180;
        JKTYPE.RobotStatus rs = new JKTYPE.RobotStatus();

        #region log
        public delegate void PrintMssgDelegate(string s);
        public delegate void UiDelegate();
        public delegate void UiupdateDelegate(JKTYPE.RobotStatus rs);
        public void PrintMssg(string info)
        {
            textBox17.Text += string.Format("{0}\r\n", info);
        }
        //connect 
        public void con()
        {
            button28.BackColor = Color.Green;
            button28.Enabled = false;
            button28.Text = "connect";
            login = true;
        }
        //quit
        public void dis()
        {
            button28.BackColor = Color.Gray;
            button28.Enabled = true;
            button28.Text = "connect";
            login = false;
        }
        //status refresh
        public void ui_update(JKTYPE.RobotStatus rs)
        {
            label1.Text = (rs.joint_position[0]*r2d).ToString("#0.000");
            label2.Text = (rs.joint_position[1] * r2d).ToString("#0.000");
            label3.Text = (rs.joint_position[2] * r2d).ToString("#0.000");
            label4.Text = (rs.joint_position[3] * r2d).ToString("#0.000");
            label5.Text = (rs.joint_position[4] * r2d).ToString("#0.000");
            label6.Text = (rs.joint_position[5] * r2d).ToString("#0.000");
            label10.Text=rs.cartesiantran_position[0].ToString("#0.000");
            label11.Text = rs.cartesiantran_position[1].ToString("#0.000");
            label12.Text = rs.cartesiantran_position[2].ToString("#0.000");
            label16.Text = rs.cartesiantran_position[3].ToString("#0.000");
            label17.Text = rs.cartesiantran_position[4].ToString("#0.000");
            label18.Text = rs.cartesiantran_position[5].ToString("#0.000");
            if (rs.powered_on == 1)
                button30.BackColor = Color.Green;
            else
                button30.BackColor = Color.Gray;
            if (rs.enabled == 1)
                button32.BackColor = Color.Green;
            else
                button32.BackColor = Color.Gray;
            if(rs.protective_stop==1)
                Invoke(new PrintMssgDelegate(PrintMssg), "collision protect");
            if (rs.drag_status == 1)
                Invoke(new PrintMssgDelegate(PrintMssg), "draging...");
            if (rs.on_soft_limit == 1)
                Invoke(new PrintMssgDelegate(PrintMssg), "soft limit");
            if (rs.emergency_stop == 1)
                Invoke(new PrintMssgDelegate(PrintMssg), "ermergence stop!");
            if (rs.errcode == 983072)
                Invoke(new PrintMssgDelegate(PrintMssg), "failed to movl");
            if (rs.errcode == 983063)
                Invoke(new PrintMssgDelegate(PrintMssg), "cannot reach target point");
            if (rs.errcode == 983064)
                Invoke(new PrintMssgDelegate(PrintMssg), "Singularity protection");
            if (rs.errcode == 983044)
                Invoke(new PrintMssgDelegate(PrintMssg), "Inverse solution failed");
            if (rs.errcode == 983057)
                Invoke(new PrintMssgDelegate(PrintMssg), "Target position exceeded");
        }
        #endregion

        #region Window initialization
        public Teach()
        {
            InitializeComponent();
        }

        //加载
        private void Form06_teach_Load(object sender, EventArgs e)
        {
            init_ui();
        }
        //初始化界面
        private void init_ui()
        {
            comboBox1.Items.Add("Continue");
            comboBox1.Items.Add("0.01");
            comboBox1.Items.Add("0.05");
            comboBox1.Items.Add("0.10");
            comboBox1.Items.Add("0.50");
            comboBox1.Items.Add("1.00");
            comboBox1.Items.Add("5.00");
            comboBox1.Items.Add("10.0");
            comboBox2.Items.Add("Continue");
            comboBox2.Items.Add("0.01");
            comboBox2.Items.Add("0.05");
            comboBox2.Items.Add("0.10");
            comboBox2.Items.Add("0.50");
            comboBox2.Items.Add("1.00");
            comboBox2.Items.Add("5.00");
            comboBox2.Items.Add("10.0");
            comboBox1.SelectedIndex = 0;
            comboBox2.SelectedIndex = 0;
        }
        
        //close
        private void Form06_teach_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (login)
            {
                Invoke(new PrintMssgDelegate(PrintMssg), "断开机器人连接");
                jakaAPI.destory_handler(ref rshd);
                dis();
                Thread.Sleep(300);
            }
        }
        #endregion

        #region Robot arm teaching
        private void jog(int aj_num, JKTYPE.MoveMode move_mode, JKTYPE.CoordType coord_type, double vel_cmd, double pos_cmd)
        {
            if (login)
            {
                if (rs.enabled == 1)
                {
                    teach = true;
                    jakaAPI.jog(ref rshd, aj_num, move_mode, coord_type, vel_cmd, pos_cmd);
                }
                else
                {
                    Invoke(new PrintMssgDelegate(PrintMssg), "Robot not enabled ！！！");
                }
            }
            else
            {
                Invoke(new PrintMssgDelegate(PrintMssg), "Robot not connected ！！！");
            }
        }
        private void jog_stop(int joint_num)
        {
            if (teach)
            {
                jakaAPI.jog_stop(ref rshd, joint_num);
                teach = false;
            }
        }
        #region J1 axis dynamic teaching
        private void button2_MouseDown(object sender, MouseEventArgs e)
        {
            if (comboBox2.SelectedIndex == 0)
            {
                jog(0, JKTYPE.MoveMode.CONTINUE, JKTYPE.CoordType.COORD_JOINT, 0.2, 0);
            }
            else
            {
                double s1 = Convert.ToDouble(comboBox2.Text) * d2r;
                jog(0, JKTYPE.MoveMode.INCR, JKTYPE.CoordType.COORD_JOINT,0.2, s1);
            }
        }
        private void button2_MouseUp(object sender, MouseEventArgs e)
        {
            jog_stop(-1);
        }

        private void button1_MouseDown(object sender, MouseEventArgs e)
        {
            if (comboBox2.SelectedIndex == 0)
            {  
                jog(0, JKTYPE.MoveMode.CONTINUE, JKTYPE.CoordType.COORD_JOINT, -0.2, 0);
            }
            else
            {
                double s1 = Convert.ToDouble(comboBox2.Text) *d2r;
                jog(0, JKTYPE.MoveMode.INCR, JKTYPE.CoordType.COORD_JOINT, -0.2, s1);
            }
        }

        private void button1_MouseUp(object sender, MouseEventArgs e)
        {
            jog_stop(-1);
        }
        #endregion

        #region J2 axis dynamic teaching
        private void button4_MouseDown(object sender, MouseEventArgs e)
        {
            if (comboBox2.SelectedIndex == 0)
            {
                jog(1, JKTYPE.MoveMode.CONTINUE, JKTYPE.CoordType.COORD_JOINT, 0.2, 0);
            }
            else
            {
                double s1 = Convert.ToDouble(comboBox2.Text) * d2r;
                jog(1, JKTYPE.MoveMode.INCR, JKTYPE.CoordType.COORD_JOINT, 0.2, s1);
            }
        }

        private void button4_MouseUp(object sender, MouseEventArgs e)
        {
            jog_stop(-1);
        }

        private void button3_MouseDown(object sender, MouseEventArgs e)
        {
            if (comboBox2.SelectedIndex == 0)
            {
                jog(1, JKTYPE.MoveMode.CONTINUE, JKTYPE.CoordType.COORD_JOINT, -0.2, 0);
            }
            else
            {
                double s1 = Convert.ToDouble(comboBox2.Text) * d2r;
                jog(1, JKTYPE.MoveMode.INCR, JKTYPE.CoordType.COORD_JOINT, -0.2, s1);
            }
        }

        private void button3_MouseUp(object sender, MouseEventArgs e)
        {
            jog_stop(-1);
        }
        #endregion

        #region J3 axis dynamic teaching
        private void button6_MouseDown(object sender, MouseEventArgs e)
        {
            if (comboBox2.SelectedIndex == 0)
            {
                jog(2, JKTYPE.MoveMode.CONTINUE, JKTYPE.CoordType.COORD_JOINT, 0.2, 0);
            }
            else
            {
                double s1 = Convert.ToDouble(comboBox2.Text) * d2r;
                jog(2, JKTYPE.MoveMode.INCR, JKTYPE.CoordType.COORD_JOINT, 0.2, s1);
            }
        }

        private void button6_MouseUp(object sender, MouseEventArgs e)
        {
            jog_stop(-1);
        }

        private void button5_MouseDown(object sender, MouseEventArgs e)
        {
            if (comboBox2.SelectedIndex == 0)
            {
                jog(2, JKTYPE.MoveMode.CONTINUE, JKTYPE.CoordType.COORD_JOINT, -0.2, 0);
            }
            else
            {
                double s1 = Convert.ToDouble(comboBox2.Text) * d2r;
                jog(2, JKTYPE.MoveMode.INCR, JKTYPE.CoordType.COORD_JOINT, -0.2, s1);
            }
        }

        private void button5_MouseUp(object sender, MouseEventArgs e)
        {
            jog_stop(-1);
        }
        #endregion

        #region J4 axis dynamic teaching
        private void button8_MouseDown(object sender, MouseEventArgs e)
        {
            if (comboBox2.SelectedIndex == 0)
            {
                jog(3, JKTYPE.MoveMode.CONTINUE, JKTYPE.CoordType.COORD_JOINT, 0.2, 0);
            }
            else
            {
                double s1 = Convert.ToDouble(comboBox2.Text) * d2r;
                jog(3, JKTYPE.MoveMode.INCR, JKTYPE.CoordType.COORD_JOINT, 0.2, s1);
            }
        }

        private void button8_MouseUp(object sender, MouseEventArgs e)
        {
            jog_stop(-1);
        }
        private void button7_MouseDown(object sender, MouseEventArgs e)
        {
            if (comboBox2.SelectedIndex == 0)
            {
                jog(3, JKTYPE.MoveMode.CONTINUE, JKTYPE.CoordType.COORD_JOINT, -0.2, 0);
            }
            else
            {
                double s1 = Convert.ToDouble(comboBox2.Text) * d2r;
                jog(3, JKTYPE.MoveMode.INCR, JKTYPE.CoordType.COORD_JOINT, -0.2, s1);
            }
        }

        private void button7_MouseUp(object sender, MouseEventArgs e)
        {
            jog_stop(-1);
        }
        #endregion

        #region J5 axis dynamic teaching
        private void button10_MouseDown(object sender, MouseEventArgs e)
        {
            if (comboBox2.SelectedIndex == 0)
            {
                jog(4, JKTYPE.MoveMode.CONTINUE, JKTYPE.CoordType.COORD_JOINT, 0.2, 0);
            }
            else
            {
                double s1 = Convert.ToDouble(comboBox2.Text) * d2r;
                jog(4, JKTYPE.MoveMode.INCR, JKTYPE.CoordType.COORD_JOINT, 0.2, s1);
            }
        }

        private void button10_MouseUp(object sender, MouseEventArgs e)
        {
            jog_stop(-1);
        }

        private void button9_MouseDown(object sender, MouseEventArgs e)
        {
            if (comboBox2.SelectedIndex == 0)
            {
                jog(4, JKTYPE.MoveMode.CONTINUE, JKTYPE.CoordType.COORD_JOINT, -0.2, 0);
            }
            else
            {
                double s1 = Convert.ToDouble(comboBox2.Text) * d2r;
                jog(4, JKTYPE.MoveMode.INCR, JKTYPE.CoordType.COORD_JOINT, -0.2, s1);
            }
        }

        private void button9_MouseUp(object sender, MouseEventArgs e)
        {
            jog_stop(-1);
        }
        #endregion

        #region J6 axis dynamic teaching
        private void button12_MouseDown(object sender, MouseEventArgs e)
        {
            if (comboBox2.SelectedIndex == 0)
            {
                jog(5, JKTYPE.MoveMode.CONTINUE, JKTYPE.CoordType.COORD_JOINT, 0.2, 0);
            }
            else
            {
                double s1 = Convert.ToDouble(comboBox2.Text) * d2r;
                jog(5, JKTYPE.MoveMode.INCR, JKTYPE.CoordType.COORD_JOINT, 0.2, s1);
            }
        }

        private void button12_MouseUp(object sender, MouseEventArgs e)
        {
            jog_stop(-1);
        }

        private void button11_MouseDown(object sender, MouseEventArgs e)
        {
            if (comboBox2.SelectedIndex == 0)
            {
                jog(5, JKTYPE.MoveMode.CONTINUE, JKTYPE.CoordType.COORD_JOINT, -0.2, 0);
            }
            else
            {
                double s1 = Convert.ToDouble(comboBox2.Text) * d2r;
                jog(5, JKTYPE.MoveMode.INCR, JKTYPE.CoordType.COORD_JOINT, -0.2, s1);
            }
        }

        private void button11_MouseUp(object sender, MouseEventArgs e)
        {
            jog_stop(-1);
        }
        #endregion

        #region X-direction linear teaching
        private void button14_MouseDown(object sender, MouseEventArgs e)
        {
            if (comboBox2.SelectedIndex == 0)
            {
                jog(0, JKTYPE.MoveMode.CONTINUE, JKTYPE.CoordType.COORD_BASE, 30, 0);
            }
            else
            {
                double s1 = Convert.ToDouble(comboBox2.Text);
                jog(0, JKTYPE.MoveMode.INCR, JKTYPE.CoordType.COORD_BASE, 30, s1);
            }
        }

        private void button14_MouseUp(object sender, MouseEventArgs e)
        {
            jog_stop(-1);
        }

        private void button13_MouseDown(object sender, MouseEventArgs e)
        {
            if (comboBox2.SelectedIndex == 0)
            {
                jog(0, JKTYPE.MoveMode.CONTINUE, JKTYPE.CoordType.COORD_BASE, -30, 0);
            }
            else
            {
                double s1 = Convert.ToDouble(comboBox2.Text);
                jog(0, JKTYPE.MoveMode.INCR, JKTYPE.CoordType.COORD_BASE, -30, s1);
            }
        }

        private void button13_MouseUp(object sender, MouseEventArgs e)
        {
            jog_stop(-1);
        }
        #endregion

        #region Y-direction linear teaching
        private void button16_MouseDown(object sender, MouseEventArgs e)
        {
            if (comboBox2.SelectedIndex == 0)
            {
                jog(1, JKTYPE.MoveMode.CONTINUE, JKTYPE.CoordType.COORD_BASE, 30, 0);
            }
            else
            {
                double s1 = Convert.ToDouble(comboBox2.Text);
                jog(1, JKTYPE.MoveMode.INCR, JKTYPE.CoordType.COORD_BASE, 30, s1);
            }
        }

        private void button16_MouseUp(object sender, MouseEventArgs e)
        {
            jog_stop(-1);
        }

        private void button15_MouseDown(object sender, MouseEventArgs e)
        {
            if (comboBox2.SelectedIndex == 0)
            {
                jog(1, JKTYPE.MoveMode.CONTINUE, JKTYPE.CoordType.COORD_BASE, -30, 0);
            }
            else
            {
                double s1 = Convert.ToDouble(comboBox2.Text);
                jog(1, JKTYPE.MoveMode.INCR, JKTYPE.CoordType.COORD_BASE, -30, s1);
            }
        }

        private void button15_MouseUp(object sender, MouseEventArgs e)
        {
            jog_stop(-1);
        }
        #endregion

        #region Z-direction linear teaching
        private void button18_MouseDown(object sender, MouseEventArgs e)
        {
            if (comboBox2.SelectedIndex == 0)
            {
                jog(2, JKTYPE.MoveMode.CONTINUE, JKTYPE.CoordType.COORD_BASE, 30, 0);
            }
            else
            {
                double s1 = Convert.ToDouble(comboBox2.Text);
                jog(2, JKTYPE.MoveMode.INCR, JKTYPE.CoordType.COORD_BASE, 30, s1);
            }
        }

        private void button18_MouseUp(object sender, MouseEventArgs e)
        {
            jog_stop(-1);
        }

        private void button17_MouseDown(object sender, MouseEventArgs e)
        {
            if (comboBox2.SelectedIndex == 0)
            {
                jog(2, JKTYPE.MoveMode.CONTINUE, JKTYPE.CoordType.COORD_BASE, -30, 0);
            }
            else
            {
                double s1 = Convert.ToDouble(comboBox2.Text);
                jog(2, JKTYPE.MoveMode.INCR, JKTYPE.CoordType.COORD_BASE, -30, s1);
            }
        }

        private void button17_MouseUp(object sender, MouseEventArgs e)
        {
            jog_stop(-1);
        }
        #endregion

        #region RX direction posture teaching
        private void button19_MouseDown(object sender, MouseEventArgs e)
        {
            if (comboBox2.SelectedIndex == 0)
            {
                jog(3, JKTYPE.MoveMode.CONTINUE, JKTYPE.CoordType.COORD_BASE, 10, 0);
            }
            else
            {
                double s1 = Convert.ToDouble(comboBox2.Text);
                jog(3, JKTYPE.MoveMode.INCR, JKTYPE.CoordType.COORD_BASE, 10, s1);
            }
        }

        private void button19_MouseUp(object sender, MouseEventArgs e)
        {
            jog_stop(-1);
        }

        private void button20_MouseDown(object sender, MouseEventArgs e)
        {
            if (comboBox2.SelectedIndex == 0)
            {
                jog(3, JKTYPE.MoveMode.CONTINUE, JKTYPE.CoordType.COORD_BASE, -10, 0);
            }
            else
            {
                double s1 = Convert.ToDouble(comboBox2.Text);
                jog(3, JKTYPE.MoveMode.INCR, JKTYPE.CoordType.COORD_BASE, -10, s1);
            }
        }

        private void button20_MouseUp(object sender, MouseEventArgs e)
        {
            jog_stop(-1);
        }
        #endregion

        #region RY direction posture teaching
        private void button22_MouseDown(object sender, MouseEventArgs e)
        {
            if (comboBox2.SelectedIndex == 0)
            {
                jog(4, JKTYPE.MoveMode.CONTINUE, JKTYPE.CoordType.COORD_BASE, 10, 0);
            }
            else
            {
                double s1 = Convert.ToDouble(comboBox2.Text);
                jog(4, JKTYPE.MoveMode.INCR, JKTYPE.CoordType.COORD_BASE, 10, s1);
            }
        }

        private void button22_MouseUp(object sender, MouseEventArgs e)
        {
            jog_stop(-1);
        }

        private void button21_MouseDown(object sender, MouseEventArgs e)
        {
            if (comboBox2.SelectedIndex == 0)
            {
                jog(4, JKTYPE.MoveMode.CONTINUE, JKTYPE.CoordType.COORD_BASE, -10, 0);
            }
            else
            {
                double s1 = Convert.ToDouble(comboBox2.Text);
                jog(4, JKTYPE.MoveMode.INCR, JKTYPE.CoordType.COORD_BASE, -10, s1);
            }
        }

        private void button21_MouseUp(object sender, MouseEventArgs e)
        {
            jog_stop(-1);
        }
        #endregion

        #region RZ direction posture teaching
        private void button24_MouseDown(object sender, MouseEventArgs e)
        {
            if (comboBox2.SelectedIndex == 0)
            {
                jog(5, JKTYPE.MoveMode.CONTINUE, JKTYPE.CoordType.COORD_BASE, 10, 0);
            }
            else
            {
                double s1 = Convert.ToDouble(comboBox2.Text);
                jog(5, JKTYPE.MoveMode.INCR, JKTYPE.CoordType.COORD_BASE, 10, s1);
            }
        }

        private void button24_MouseUp(object sender, MouseEventArgs e)
        {
            jog_stop(-1);
        }

        private void button23_MouseDown(object sender, MouseEventArgs e)
        {
            if (comboBox2.SelectedIndex == 0)
            {
                jog(5, JKTYPE.MoveMode.CONTINUE, JKTYPE.CoordType.COORD_BASE, -10, 0);
            }
            else
            {
                double s1 = Convert.ToDouble(comboBox2.Text);
                jog(5, JKTYPE.MoveMode.INCR, JKTYPE.CoordType.COORD_BASE, -10, s1);
            }
        }

        private void button23_MouseUp(object sender, MouseEventArgs e)
        {
            jog_stop(-1);
        }
        #endregion

        #endregion

        #region Robot connection
        //login
        private void button28_Click(object sender, EventArgs e)
        {
            button28.Enabled = false;
            button28.Text = "connecting...";
            Thread thread1 = new Thread(th_Connect_to_Robot);//Creating a Thread               
            thread1.IsBackground = true;//Set the form thread to synchronize with the background             
            thread1.Start(); //start thread   
        }
        //connect the robot
        private void th_Connect_to_Robot()

        {
            Invoke(new PrintMssgDelegate(PrintMssg), "begain connecting robot...");
            string ip = textBox18.Text;
            int ret = jakaAPI.create_handler(ip.ToCharArray(), ref rshd);
            if (ret == 0)
            {
                Invoke(new UiDelegate(con));
                Invoke(new PrintMssgDelegate(PrintMssg), "connect successfully...");
                try
                {
                    while (login)
                    {
                        Thread.Sleep(300);
                        jakaAPI.get_robot_status(ref rshd, ref rs);
                        Invoke(new UiupdateDelegate(ui_update), rs);
                    }
                }
                catch
                {

                }
                for(int i=0;i<6;i++)
                {
                    rs.cartesiantran_position[i] = 0;
                    rs.joint_position[i] = 0;
                }
                rs.enabled = 0;
                rs.powered_on = 0;
                Invoke(new UiupdateDelegate(ui_update), rs);
            }
            else
            {
                Invoke(new UiDelegate(dis));
                Invoke(new PrintMssgDelegate(PrintMssg), "Failed to connect to the robot");
            }
        }
        //logout
        private void button29_Click(object sender, EventArgs e)
        {
            if (login)
            {
                Invoke(new PrintMssgDelegate(PrintMssg), "Disconnect the robot");
                jakaAPI.destory_handler(ref rshd);
                dis();
            }
            else
            {
                Invoke(new PrintMssgDelegate(PrintMssg), "Robot not connected ！！！");
            }
        }
        #endregion

        #region log
        //clear log message
        private void button27_Click(object sender, EventArgs e)
        {
            textBox17.Text = "";
        }
        //message text show
        private void textBox17_TextChanged(object sender, EventArgs e)
        {
            if (textBox17.Text.Length >= 2000)
            {
                textBox17.Text = textBox17.Text.Remove(0, textBox17.Text.IndexOf('\r') + 10);//删除第一属行
            }
            textBox17.SelectionStart = textBox17.Text.Length;
            textBox17.ScrollToCaret();
        }
        #endregion

        #region linear_move  joint_move
        //joint move
        private void button25_MouseDown(object sender, MouseEventArgs e)
        {
            if (login)
            {
                if (rs.enabled == 1)
                {
                    teach = true;
                    JKTYPE.JointValue joint = new JKTYPE.JointValue();
                    joint.jVal= new double[] {0,0,0,0,0,0};
                    JKTYPE.OptionalCond optional = new JKTYPE.OptionalCond();
                    joint.jVal[0]= Convert.ToDouble(textBox1.Text) * d2r;
                    joint.jVal[1] = Convert.ToDouble(textBox2.Text) * d2r;
                    joint.jVal[2] = Convert.ToDouble(textBox3.Text) * d2r;
                    joint.jVal[3] = Convert.ToDouble(textBox4.Text) * d2r;
                    joint.jVal[4] = Convert.ToDouble(textBox5.Text) * d2r;
                    joint.jVal[5] = Convert.ToDouble(textBox6.Text) * d2r;
                    double v = Convert.ToDouble(textBox7.Text)*d2r;
                    double a = Convert.ToDouble(textBox8.Text)*d2r;
                    jakaAPI.joint_move_extend(ref rshd, ref joint, JKTYPE.MoveMode.ABS, false, v, a,0, ref optional);
                }
                else
                {
                    Invoke(new PrintMssgDelegate(PrintMssg), "robot not enabled！！！");
                }
            }
            else
            {
                Invoke(new PrintMssgDelegate(PrintMssg), "robot not connected！！！");
            }
        }

        private void button25_MouseUp(object sender, MouseEventArgs e)
        {
            if(teach)
            {
                teach = false;
                jakaAPI.motion_abort(ref rshd);
            }
        }
        //linear_move
        private void button26_MouseDown(object sender, MouseEventArgs e)
        {
            if (login)
            {
                if (rs.enabled == 1)
                {
                    teach = true;
                    teach = true;
                    JKTYPE.CartesianPose pos = new JKTYPE.CartesianPose();
                    JKTYPE.OptionalCond optional = new JKTYPE.OptionalCond();
                    pos.tran.x = Convert.ToDouble(textBox11.Text);
                    pos.tran.y = Convert.ToDouble(textBox12.Text);
                    pos.tran.z = Convert.ToDouble(textBox13.Text);
                    pos.rpy.rx = Convert.ToDouble(textBox14.Text) * d2r;
                    pos.rpy.ry = Convert.ToDouble(textBox15.Text) * d2r;
                    pos.rpy.rz = Convert.ToDouble(textBox16.Text) * d2r;
                    double v = Convert.ToDouble(textBox9.Text);
                    double a = Convert.ToDouble(textBox10.Text);
                    jakaAPI.linear_move_extend(ref rshd, ref pos, JKTYPE.MoveMode.ABS, false, v, a, 0, ref optional);
                }
                else
                {
                    Invoke(new PrintMssgDelegate(PrintMssg), "robot not enabled！！！");
                }
            }
            else
            {
                Invoke(new PrintMssgDelegate(PrintMssg), "robot not connected！！！");
            }
        }

        private void button26_MouseUp(object sender, MouseEventArgs e)
        {
            if (teach)
            {
                teach = false;
                jakaAPI.motion_abort(ref rshd);
            }
        }
        #endregion

        #region powr_on enable_robot
        //上电
        private void button30_Click(object sender, EventArgs e)
        {
            Thread thread1 = new Thread(th_power_on);//创建一个线程                
            thread1.IsBackground = true;//将窗体线程设置为与后台同步             
            thread1.Start(); //启动线程
        }
        //下电
        private void button31_Click(object sender, EventArgs e)
        {
            Thread thread1 = new Thread(th_power_off);//创建一个线程                
            thread1.IsBackground = true;//将窗体线程设置为与后台同步             
            thread1.Start(); //启动线程
        }
        //上使能
        private void button32_Click(object sender, EventArgs e)
        {
            Thread thread1 = new Thread(th_enable);//创建一个线程                
            thread1.IsBackground = true;//将窗体线程设置为与后台同步             
            thread1.Start(); //启动线程
        }
        //下使能
        private void button33_Click(object sender, EventArgs e)
        {
            Thread thread1 = new Thread(th_disenable);//创建一个线程                
            thread1.IsBackground = true;//将窗体线程设置为与后台同步             
            thread1.Start(); //启动线程
        }
        private void th_power_on()
        {
            if(login)
            {
                if(rs.powered_on==1)
                {
                    Invoke(new PrintMssgDelegate(PrintMssg), "The robot is powered on ！！！");
                }
                else
                {
                    Invoke(new PrintMssgDelegate(PrintMssg), "Power on the robot ");
                    jakaAPI.power_on(ref rshd);
                }
            }
            else
            {
                Invoke(new PrintMssgDelegate(PrintMssg), "robot not connected！！！");
            }
        }
        private void th_power_off()
        {
            if (login)
            {
                if(rs.enabled==1)
                {
                    Invoke(new PrintMssgDelegate(PrintMssg), "Please disable the robot first！！");
                }
                else
                {
                    if(rs.powered_on==1)
                    {
                        Invoke(new PrintMssgDelegate(PrintMssg), "power off");
                        jakaAPI.power_off(ref rshd);
                    }
                    else
                    {
                        Invoke(new PrintMssgDelegate(PrintMssg), "The robot is powered off！！！");
                    }
                }
            }
            else
            {
                Invoke(new PrintMssgDelegate(PrintMssg), "robot not connected！！！");
            }
        }
        private void th_enable()
        {
            if (login)
            {
                if(rs.enabled==1)
                {
                    Invoke(new PrintMssgDelegate(PrintMssg), "Robot enabled！！！");
                }
                else
                {
                    Invoke(new PrintMssgDelegate(PrintMssg), "enable the robot");
                    jakaAPI.enable_robot(ref rshd);
                }
            }
            else
            {
                Invoke(new PrintMssgDelegate(PrintMssg), "robot not connected！！！");
            }
        }
        private void th_disenable()
        {
            if (login)
            {
                if(rs.enabled==1)
                {
                    Invoke(new PrintMssgDelegate(PrintMssg), "disable the robot");
                    jakaAPI.disable_robot(ref rshd);
                }
                else
                {
                    Invoke(new PrintMssgDelegate(PrintMssg), "robot not enabled！！！");
                }
            }
            else
            {
                Invoke(new PrintMssgDelegate(PrintMssg), "robot not connected！！！");
            }
        }
        #endregion
    
    }
}