#include <string> 
#include <vector> 
#include <iostream>
#include <chrono>
#include "JAKAZuRobot.h" // 确保包含此行
#include <thread>
int main(int argc, char** argv)
{

    JAKAZuRobot demo;

    demo.login_in("172.30.3.172");
    //sleep(2);

    try {
        demo.power_on();
    }
    catch (const std::exception& e) {
        std::cerr << e.what() << '\n';
    }
    //sleep(2);
    try {
        demo.enable_robot();
    }
    catch (const std::exception& e) {
        std::cerr << e.what() << '\n';
    }
    //sleep(2);

    CartesianPose tcp_pos;
    int ret;
    char ver[100];
    demo.get_tcp_position(&tcp_pos);
    demo.get_sdk_version(ver);

    std::cout << "SDK version is :" << ver << std::endl;
    std::cout << "tcp_pos is :\n x: " << tcp_pos.tran.x << "y: " << tcp_pos.tran.y << "z: " << tcp_pos.tran.z << std::endl;

    std::cout << "tcp_pos is :\n rx: " << tcp_pos.rpy.rx << "ry: " << tcp_pos.rpy.ry << "rz: " << tcp_pos.rpy.rz << std::endl;
    auto now = std::chrono::system_clock::now().time_since_epoch();
    auto ms = std::chrono::duration_cast<std::chrono::milliseconds>(now).count();
    std::cout << "Current s: " << std::fixed << ((double)ms) / 1000.0f << std::endl;
    tcp_pos.tran.y = tcp_pos.tran.y + 60.0;
    ret = demo.linear_move(&tcp_pos, ABS, TRUE, 10, 10, 1, NULL);
    std::cout << "ret==" << ret << std::endl;
    std::cout << "linear_move finish! " << std::endl;
    now = std::chrono::system_clock::now().time_since_epoch();
    
    return 0;
}